package com.example.timer;

import android.content.SharedPreferences;
import android.graphics.Typeface;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.TypedValue;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Spinner;
import android.graphics.fonts.*;
import android.widget.TextView;
import android.widget.Toast;
import android.graphics.Color;


import com.android.colorpicker.ColorPickerDialog;
import com.android.colorpicker.ColorPickerSwatch;

public class ParametreActivity extends AppCompatActivity {

    SharedPreferences settings;
    private Spinner spinner1;
    private Spinner spinner2;
    private Spinner spinner3;
    private TextView txt1;
    private TextView txt2;
    private TextView txt3;
    private float petit = 10;
    private float moyen = 15;
    private float grand = 20;
    private String animation = "";
    private float size = 10;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        settings = getSharedPreferences("austine", 0);

        txt1 = findViewById(R.id.text_view_animation);
        txt2 = findViewById(R.id.text_view_choix_police);
        txt3 = findViewById(R.id.text_view_taille_police);
        txt1.setTextColor(settings.getInt("Color", getResources().getColor(R.color.colorPrimary)));
        txt2.setTextColor(settings.getInt("Color", getResources().getColor(R.color.colorPrimary)));
        txt3.setTextColor(settings.getInt("Color", getResources().getColor(R.color.colorPrimary)));

        Spinner spinner1 = (Spinner) findViewById(R.id.spinner_choix_animation);
        // Create an ArrayAdapter using the string array and a default spinner layout
        ArrayAdapter<CharSequence> adapter_anim = ArrayAdapter.createFromResource(this,
                R.array.menu_animation, android.R.layout.simple_spinner_item);
        // Specify the layout to use when the list of choices appears
        adapter_anim.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        // Apply the adapter to the spinner
        spinner1.setAdapter(adapter_anim);
        spinner1.setSelection(settings.getInt("animationPos",0));

        Spinner spinner2 = (Spinner) findViewById(R.id.spinner_choix_police);
        ArrayAdapter<CharSequence> adapter_choix_pol = ArrayAdapter.createFromResource(this,
                R.array.menu_choix_police, android.R.layout.simple_spinner_item);
        adapter_choix_pol.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner2.setAdapter(adapter_choix_pol);
        spinner2.setSelection(settings.getInt("policePos",0));

        Spinner spinner3 = (Spinner) findViewById(R.id.spinner_taille_police);
        ArrayAdapter<CharSequence> adapter_taille_pol = ArrayAdapter.createFromResource(this,
                R.array.menu_taille_police, android.R.layout.simple_spinner_item);
        adapter_taille_pol.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        spinner3.setAdapter(adapter_taille_pol);
        spinner3.setSelection(settings.getInt("sizePos",0));

        spinner1.setOnItemSelectedListener(new spinner1Listenner());
        spinner2.setOnItemSelectedListener(new spinner2Listenner());
        spinner3.setOnItemSelectedListener(new spinner3Listenner());


    }

    public class spinner1Listenner implements AdapterView.OnItemSelectedListener {

        public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {
            Toast.makeText(parent.getContext(),
                    "OnItemSelectedListener : " + parent.getItemAtPosition(pos).toString(),
                    Toast.LENGTH_SHORT).show();

            animation = parent.getItemAtPosition(pos).toString();


            SharedPreferences.Editor editor = settings.edit();
            editor.putString("animation", animation);
            editor.putInt("animationPos", pos);
            editor.apply();
        }

        @Override
        public void onNothingSelected(AdapterView<?> arg0) {
            // TODO Auto-generated method stub
        }
    }

    public class spinner2Listenner implements AdapterView.OnItemSelectedListener {

        public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {
            Toast.makeText(parent.getContext(),
                    "OnItemSelectedListener : " + parent.getItemAtPosition(pos).toString(),
                    Toast.LENGTH_SHORT).show();

            Typeface typeface = Typeface.createFromAsset(getAssets(),parent.getItemAtPosition(pos).toString()+".ttf");
            txt1.setTypeface(typeface);
            txt2.setTypeface(typeface);
            txt3.setTypeface(typeface);

            SharedPreferences.Editor editor = settings.edit();
            editor.putString("police", parent.getItemAtPosition(pos).toString()+".ttf");
            editor.putInt("policePos", pos);
            editor.apply();
        }

        @Override
        public void onNothingSelected(AdapterView<?> arg0) {
            // TODO Auto-generated method stub
        }
    }

    public class spinner3Listenner implements AdapterView.OnItemSelectedListener {

        public void onItemSelected(AdapterView<?> parent, View view, int pos,long id) {
            /*Toast.makeText(parent.getContext(),
                    "OnItemSelectedListener : " + parent.getItemAtPosition(pos).toString(),
                    Toast.LENGTH_SHORT).show();*/

            if(parent.getItemAtPosition(pos).toString().toLowerCase().equals("petit")){
                size = petit;
            }
            else if(parent.getItemAtPosition(pos).toString().toLowerCase().equals("moyen")){
                size = moyen;
            }
            else if(parent.getItemAtPosition(pos).toString().toLowerCase().equals("grand")){
                size = grand;
            }
            txt1.setTextSize(TypedValue.COMPLEX_UNIT_PT, size);
            txt2.setTextSize(TypedValue.COMPLEX_UNIT_PT, size);
            txt3.setTextSize(TypedValue.COMPLEX_UNIT_PT, size);
            //((TextView) parent.getChildAt(0)).setTextColor(Color.BLUE);
            //((TextView) parent.getChildAt(0)).setTextSize(size+10);
            //((TextView) spinner1.getChildAt(0)).setTextSize(size+8);
            //((TextView) spinner3.getChildAt(0)).setTextSize(size+8);

            SharedPreferences.Editor editor = settings.edit();
            editor.putFloat("size", size);
            editor.putInt("sizePos", pos);
            editor.apply();
        }

        @Override
        public void onNothingSelected(AdapterView<?> arg0) {
            // TODO Auto-generated method stub
        }
    }

    public void showColourPicker(View view) {
        final ColorPickerDialog colorPickerDialog = new ColorPickerDialog();
        colorPickerDialog.initialize(R.string.color_picker_default_title,
                new int[] {
                        getResources().getColor(R.color.colorPrimary),
                        getResources().getColor(R.color.colorAccent),
                        getResources().getColor(R.color.colorPrimaryDark),
                        Color.BLACK,
                        Color.CYAN,
                        Color.GRAY,
                        Color.BLUE,
                        Color.GREEN,
                        Color.MAGENTA,
                        Color.YELLOW,
                        Color.RED,
                        getResources().getColor(R.color.colorPurple)

                }, getResources().getColor(R.color.colorPrimary), 4, 2);
        colorPickerDialog.setSelectedColor(settings.getInt("Color",  getResources().getColor(R.color.colorPrimary)));
        colorPickerDialog.setOnColorSelectedListener(new ColorPickerSwatch.OnColorSelectedListener() {
            @Override
            public void onColorSelected(int color) {

                SharedPreferences.Editor editor = settings.edit();
                editor.putInt("Color", color);

                // Commit the edits!
                editor.apply();

                recreate();
            }
        });

        android.app.FragmentManager fm = this.getFragmentManager();
        colorPickerDialog.show(fm, "colorpicker");
    }
}
